/*
 * taskview-manager.h
 *
 * TaskviewManager
 *
 * Copyright © 2010 Salomon Sickert
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 3 of the licence or (at
 * your option) any later version.
 *
 * See the included COPYING.LESSER file for more information.
 *
 * Authors:
 *    Salomon Sickert <sickert@in.tum.de>
 */

#ifndef __TASKVIEW_MANAGER_H__
#define __TASKVIEW_MANAGER_H__

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>

G_BEGIN_DECLS

#define TASKVIEW_TYPE_MANAGER	(taskview_manager_get_type ())
#define TASKVIEW_MANAGER(obj)	(G_TYPE_CHECK_INSTANCE_CAST ((obj), TASKVIEW_TYPE_MANAGER, TaskviewManager))
#define TASKVIEW_MANAGER_CLASS(obj)	(G_TYPE_CHECK_CLASS_CAST ((obj), TASKVIEW_TYPE_MANAGER, TaskviewManagerClass))
#define TASKVIEW_IS_MANAGER(obj)	(G_TYPE_CHECK_INSTANCE_TYPE ((obj), TASKVIEW_TYPE_MANAGER))
#define TASKVIEW_IS_MANAGER_CLASS(obj)	(G_TYPE_CHECK_CLASS_TYPE ((obj), TASKVIEW_TYPE_MANAGER))
#define TASKVIEW_MANAGER_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), TASKVIEW_TYPE_MANAGER, TaskviewManagerClass))

typedef struct _TaskviewManager TaskviewManager;
typedef struct _TaskviewManagerClass TaskviewManagerClass;
typedef struct _TaskviewManagerPrivate TaskviewManagerPrivate;

struct _TaskviewManager
{
  GObject parent;
  TaskviewManagerPrivate *priv;
};

struct _TaskviewManagerClass
{
  GObjectClass parent_class;
};

GType taskview_manager_get_type (void);

TaskviewManager* taskview_manager_dup (void);

// Mode, true -> added, false -> removed
void taskview_manager_tv_changed (TaskviewManager *self,
                                  const gchar *object_path,
                                  gboolean mode);

void taskview_manager_property_changed (TaskviewManager *self,
                                        const gchar *object_path,
                                        const gchar *interface,
                                        GVariantBuilder *changed_properties,
                                        GVariantBuilder *invalidated_properties);

G_END_DECLS

#endif