/*
 * taskview-monitor.h
 *
 * TaskviewMonitor
 *
 * Copyright © 2010 Salomon Sickert
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the licence or (at
 * your option) any later version.
 *
 * See the included COPYING file for more information.
 *
 * Authors:
 *    Salomon Sickert <sickert@in.tum.de>
 */

#ifndef __TASKVIEW_MONITOR_H__
#define __TASKVIEW_MONITOR_H__

#include "taskview-application-proxy.h"
#include <glib-object.h>
#include <gio/gio.h>

G_BEGIN_DECLS

#define TASKVIEW_TYPE_MONITOR	(taskview_monitor_get_type ())
#define TASKVIEW_MONITOR(obj)	(G_TYPE_CHECK_INSTANCE_CAST ((obj), TASKVIEW_TYPE_MONITOR, TaskviewMonitor))
#define TASKVIEW_MONITOR_CLASS(obj)	(G_TYPE_CHECK_CLASS_CAST ((obj), TASKVIEW_TYPE_MONITOR, TaskviewMonitorClass))
#define TASKVIEW_IS_MONITOR(obj)	(G_TYPE_CHECK_INSTANCE_TYPE ((obj), TASKVIEW_TYPE_MONITOR))
#define TASKVIEW_IS_MONITOR_CLASS(obj)	(G_TYPE_CHECK_CLASS_TYPE ((obj), TASKVIEW_TYPE_MONITOR))
#define TASKVIEW_MONITOR_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), TASKVIEW_TYPE_MONITOR, TaskviewMonitorClass))

typedef struct _TaskviewMonitor TaskviewMonitor;
typedef struct _TaskviewMonitorClass TaskviewMonitorClass;
typedef struct _TaskviewMonitorPrivate TaskviewMonitorPrivate;

struct _TaskviewMonitor
{
  GObject parent;
  TaskviewMonitorPrivate *priv;
};

struct _TaskviewMonitorClass
{
  GObjectClass parent_class;
};

GType taskview_monitor_get_type (void);

const GHashTable * 		   taskview_monitor_get_app_proxies (TaskviewMonitor *monitor);
TaskviewApplicationProxy * taskview_monitor_get_app_proxy 	(TaskviewMonitor *monitor, const gchar *name);

G_END_DECLS

#endif
